Small indentation changes.
[wizbackup.git] / wizbackup
index e023ab986d0d59f5859c36a4c35494b2c83854fe..d96ee406b01d31ac0bef2ae064580eb72716ad60 100755 (executable)
--- a/wizbackup
+++ b/wizbackup
@@ -1,6 +1,6 @@
 #!/bin/bash
 #
-# WizBackup 2.0 - Simple rsync backup
+# WizBackup 2.0 - Simple rsync backup with snapshots
 # Based on incremental-backup 0.1 by Matteo Mattei
 #
 # Copyright 2006 Matteo Mattei <matteo.mattei@gmail.com>
 #  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 
-
 if [ $# -lt 2 ]; then
        echo "Usage: $0 SOURCE DEST [RSYNC_OPTS]"
        exit 1
 fi
 
-# Fail on any error; Treat undefined variables as errors
-set -e -u
+# Treat undefined variables as errors
+set -u
 
 #####################################################################
 # CONFIGURATION
 #####################################################################
 
-# Source path
+# Source rsync URL
 SRC=$1; shift
 
-# DESTINATION DIRECTORY (must exists)
+# Destination directory (will be created if it doesn't exist)
 DEST=$1; shift
 
 # NOTE: --timeout needs to be large enough: if a large dir tree don't change a lot of time can pass without I/O
@@ -46,6 +45,9 @@ RSYNC_OPTS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-exclude
 # Number of saved snapshots
 SNAPSHOTS=45
 
+# Abort backup if the destination volume has less than these GBs free
+MIN_FREE_GB=10
+
 RESULT=500
 DATE=`date +"%Y%m%d"`
 DEST="`echo $DEST | sed -e 's/\/$//'`"
@@ -59,14 +61,12 @@ else
 fi
 
 # Error tolerant grep
-tgrep()
-{
+tgrep() {
        grep "$@"
        return 0
 }
 
-do_backup()
-{
+do_backup() {
        set -o pipefail
        echo "$(date): rsync $RSYNC_OPTS $SRC $DEST/tmp/"
        rsync $RSYNC_OPTS "$SRC" "$DEST/tmp/" 2>&1 | tgrep -v -E 'vanished|some files'
@@ -89,9 +89,7 @@ do_backup()
        set +o pipefail
 }
 
-
-do_init()
-{
+do_init() {
        # Safety net (4 slashes just in case)
        case "$DEST" in
                /|//|///|////) exit 666 ;;
@@ -105,8 +103,7 @@ do_init()
        cd "$DEST" || exit 668
 }
 
-do_prune()
-{
+do_prune() {
        local old="`ls | grep -v tmp | head -n -$SNAPSHOTS`"
        if [ ! -z "$old" ]; then
                echo "$(date): Removing oldest snapshot(s): $old..."
@@ -114,8 +111,7 @@ do_prune()
        fi
 }
 
-do_link()
-{
+do_link() {
        local newest=`ls | grep  -v tmp | tail -n 1`
        if [ -d "$DEST/tmp" ]; then
                echo "$(date): Continuing with pre-existing snapshot $DEST/tmp"
@@ -125,12 +121,28 @@ do_link()
                echo "$(date): Linking snapshot $DEST/$newest to $DEST/tmp"
                # TODO: Creating the hardlinks takes a lot of time.
                # Perhaps we could save time by recycling the oldest snapshot
-               cp -lR "$DEST/$newest" "$DEST/tmp" || exit 670
+               cp -la "$DEST/$newest" "$DEST/tmp"
+               RESULT=$?
+               if [ $RESULT -ne 0 ]; then
+                       echo "$(date): Failed to setup tmp snapshot: $RESULT. Cleaning up."
+                       rm -rf "$DEST/tmp"
+                       exit $RESULT
+               fi
        fi
 }
 
-do_test()
-{
+do_test() {
+       # TODO: test for free space and free inodes in the $DEST filesystem
+       block_size=`stat --file-system --format "%S" "$DEST"`
+       free_blocks=`stat --file-system --format "%f" "$DEST"`
+       free_inodes=`stat --file-system --format "%d" "$DEST"`
+       free_gb=$((block_size * free_blocks / 1024 / 1024 / 1024))
+
+       if [ "$free_gb" -lt "$MIN_FREE_GB" ]; then
+               echo "$(date): Aborting due to insufficient free space ${free_gb}GB."
+               exit 670
+       fi
+
        # Avoid clobbering the latest snapshot if the remote host does
        # not allow us to connect
        # --contimeout: sometimes hangs on connection...
@@ -142,14 +154,15 @@ do_test()
        fi
 }
 
-######################
-# MAIN
-######################
+######################################
+# Main
+######################################
 
 # make sure to be root
 if (( `id -u` != 0 )); then { echo "Sorry, must be root.  Exiting..."; exit; } fi
 
-echo "$(date): START backup: $SRC -> $DEST"
+echo "$(date): BEGIN backup: $SRC -> $DEST"
+echo "$(date): $0 $SRC $DEST $@"
 do_init
 do_prune
 do_test